
let rec print l = match l with
  | [] -> print_newline ()
  | x :: r -> let _ = print_int x in let _ = print_string ";" in print r

let rec append l1 l2 = match l1 with
  | [] -> l2
  | x :: xs -> x :: append xs l2

let rec partition2 le x l = match l with
  | [] -> ([],[])
  | y :: s -> 
      let (l,r) = partition2 le x s in if le y x then (y::l,r) else (l,y::r)

let rec qsort2 le l = 
  let partition' = partition2 le in
  match l with
  | [] -> []
  | x :: xs -> match xs with
      | [] -> [x]
      | y :: ys -> let (l,r) = partition' x (y :: ys) in 
		   append (qsort2 le l)  (x :: qsort2 le r)

let qsort = qsort2 (function x -> function y -> x <= y) 

let _ = print (qsort [1;2;3])
let _ = print (qsort [3;2;1])
let _ = print (qsort [2;1;3])
let _ = print (qsort [1;1;1;1;2])
let _ = print (qsort [2;1;1;1;1])
let _ = print (qsort [2;1;4;8;2;3;1;1;1])
