
let rev l =
  let rec rev_aux acc l = match l with
      [] -> acc
    | x :: r -> rev_aux (x :: acc) r
  in 
  rev_aux [] l

(* queues *)

let empty = ([], [])

let push x (i,o) = (x :: i, o)

let null = (-1, ([],[]))

let pop (i,o) = match o with
    [] -> (match rev i with
               [] -> null
	     | x :: o -> (x, ([], o)))
  | x :: o -> (x, (i, o))

let print (i,o) =
  let rec print_l l = match l with
    [] -> ()
  | x :: r -> let _ = print_int x in let _ = print_string ";" in print_l r
  in
  let _ = print_l i in
  let _ = print_l (rev o) in
  print_newline ()

let q = push 1 (push 2 (push 3 empty))

let _ = print q

let (x,q) = pop q
let _ = let _ = print_int x in print_newline ()
let _ = print q

let q = push 4 (push 5 q)
let _ = print q

let (x,q) = let (_,q) = pop q in let (_,q) = pop q in pop q
let _ = let _ = print_int x in print_newline ()
let _ = print q

let (x,q) = pop q
let _ = let _ = print_int x in print_newline ()
let _ = print q
